﻿"use strict";

function Cat() {

    this.image = [];
    this.text = [];

    this.i_currentFrame = 0;
    this.i_currentText = 0;
    this.i_baseFrame = 0;
    this.i_frameDelay = 8;
    this.i_type = 0;
    this.b_visible = false;

    this.fu_LoadContent = function () {
        for (var i = 0; i <= 9; i++)
            this.image[i] = new GameSprite();

        this.s_assetName = "cat";

        this.image[0].fu_Initialize(this.s_assetName + "-0");
        this.image[1].fu_Initialize(this.s_assetName + "-1");
        this.image[2].fu_Initialize(this.s_assetName + "-2");
        this.image[3].fu_Initialize(this.s_assetName + "-3");
        this.image[4].fu_Initialize(this.s_assetName + "-4");
        this.image[5].fu_Initialize(this.s_assetName + "-5");
        this.image[6].fu_Initialize(this.s_assetName + "-6");
        this.image[7].fu_Initialize(this.s_assetName + "-7");
        this.image[8].fu_Initialize(this.s_assetName + "-8");
        this.image[9].fu_Initialize(this.s_assetName + "-9");
    }

    this.fu_Initialize = function (vec, i_type) {

        this.position = new GameVec(vec.i_x, vec.i_y);
        this.i_type = i_type;

        for (var i = 0; i <= 4; i++) {
            this.text[i] = new GameText();

            var temp = parseInt(this.i_type * 5 + i);

            if (GameConstants.B_DEBUG) { console.log(temp); }

            this.text[i].text = GameConstants.AS_BUTTONS[(this.i_type * 5) + i];
            this.text[i].size = Math.floor(48);
            this.text[i].font = "FONTYO";
            this.text[i].position = new GameVec(this.position.i_x + 22, this.position.i_y - 25);
            this.text[i].alignment = GameTextAlignment.CENTER;
            this.text[i].bIsHUD = true;
            //this.text[i].color = new GameColor(255, 255, 255);
            this.text[i].alpha = 1;

        }

 
    }

    this.fu_Update = function () {

        if (this.i_frameDelay <= 0) {
            this.i_currentFrame++;
            if (this.i_currentFrame >= this.i_baseFrame + 2) {
                this.i_currentFrame = this.i_baseFrame;
            } else if (this.i_currentFrame < this.i_baseFrame) {
                if (this.i_baseFrame % 2 > 0) {
                    this.i_currentFrame = this.i_baseFrame + 1;
                } else {
                    this.i_currentFrame = this.i_baseFrame;
                }
            }
            this.i_frameDelay = 8;
        } else
            this.i_frameDelay--;

        this.fu_TidyUp();
    }

    this.fu_Draw = function () {

        if (this.b_visible) {
            this.image[this.i_currentFrame].fu_Draw();
            this.text[this.i_currentText].fu_Draw();
        }

    }

    this.fu_TidyUp = function () {
        this.image[this.i_currentFrame].position.i_x = this.position.i_x;
        this.image[this.i_currentFrame].position.i_y = this.position.i_y;
    }

    this.fu_SetCurrentFrame = function (i_base) {
        this.i_baseFrame = i_base;
        if (this.i_currentFrame % 2 > 0) {
            this.i_currentFrame = this.i_baseFrame + 1;
        } else {
            this.i_currentFrame = this.i_baseFrame;
        }

        switch(i_base){
            case 0:
                this.i_currentText = 0;
                break;
            case 2:
                this.i_currentText = 1;
                break;
            case 4:
                this.i_currentText = 2;
                break;
            case 6:
                this.i_currentText = 3;
                break;
            case 8:
                this.i_currentText = 4;
                break;
        }
    }

}