﻿"use strict";

function CatManager() {

    this.i_cats = 8;
    this.aclo_cats = [];
    this.i_interval = 30;
    this.i_key = 0;
    this.i_type = null;

    this.avec_cats = [
        new GameVec(150, 300),
        new GameVec(150, 100),
        new GameVec(400, 100),
        new GameVec(650, 100),
        new GameVec(650, 300),
        new GameVec(650, 500),
        new GameVec(400, 500),
        new GameVec(150, 500),
    ];

    this.cat_positions_enum = [
        0,
        1,
        2,
        3,
        4,
        5,
        6,
        7,
    ]

    this.cat_positions = {
        LEFT: 0,
        LEFTTOP: 1,
        TOP: 2,
        RIGHTTOP: 3,
        RIGHT: 4,
        RIGHTBOTTOM: 5,
        BOTTOM: 6,
        LEFTBOTTOM: 7,
    }

    this.cat_colors = {
        RED: 0,
        YELLOW: 2,
        GREEN: 4,
        BLUE: 6,
        PURPLE: 8,
    }

    this.fu_LoadContent = function () {
        for (var i = this.i_cats; --i >= 0;) {
            this.aclo_cats[i] = new Cat();
            this.aclo_cats[i].fu_LoadContent();
        }

    }

    this.fu_Initialize = function () {
        for (var i = this.i_cats; --i >= 0;)
            this.aclo_cats[i].fu_Initialize(this.avec_cats[i], this.cat_positions_enum[i]);
    }

    this.fu_Update = function () {
        if (this.i_interval <= 0) {
            this.i_interval = 30;
            this.i_key = GameRandom.fu_RandomIntFromInterval(0, 39);

            if (this.i_key <= 39 && this.i_key > 34) {
                this.i_type = this.cat_positions.LEFTBOTTOM;
                if (GameConstants.B_DEBUG) { console.log("CAT BOTTOM LEFT"); }
            }
            if (this.i_key <= 34 && this.i_key > 29) {
                this.i_type = this.cat_positions.BOTTOM;
                if (GameConstants.B_DEBUG) { console.log("CAT BOTTOM"); }
            }
            if (this.i_key <= 29 && this.i_key > 24) {
                this.i_type = this.cat_positions.RIGHTBOTTOM;
                if (GameConstants.B_DEBUG) { console.log("CAT BOTTOM RIGHT"); }
            }
            if (this.i_key <= 24 && this.i_key > 19) {
                this.i_type = this.cat_positions.RIGHT;
                if (GameConstants.B_DEBUG) { console.log("CAT RIGHT"); }
            }
            if (this.i_key <= 19 && this.i_key > 14) {
                this.i_type = this.cat_positions.RIGHTTOP;
                if (GameConstants.B_DEBUG) { console.log("CAT TOP RIGHT"); }
            }
            if (this.i_key <= 14 && this.i_key > 9) {
                this.i_type = this.cat_positions.TOP;
                if (GameConstants.B_DEBUG) { console.log("CAT TOP"); }
            }
            if (this.i_key <= 9 && this.i_key > 4) {
                this.i_type = this.cat_positions.LEFTTOP;
                if (GameConstants.B_DEBUG) { console.log("CAT TOP LEFT"); }
            }
            if (this.i_key <= 4 && this.i_key >= 0) {
                this.i_type = this.cat_positions.LEFT;
                if (GameConstants.B_DEBUG) { console.log("CAT LEFT"); }
            }

            if (!this.aclo_cats[this.i_type].b_visible) {

                this.aclo_cats[this.i_type].b_visible = true;
                this.aclo_cats[this.i_type].i_key = this.i_key;

                this.i_key = this.i_key % 5;

                switch (this.i_key) {
                    case 0:
                        this.aclo_cats[this.i_type].fu_SetCurrentFrame(this.cat_colors.RED);
                        if (GameConstants.B_DEBUG) { console.log("CAT RED"); }
                        break;
                    case 1:
                        this.aclo_cats[this.i_type].fu_SetCurrentFrame(this.cat_colors.YELLOW);
                        if (GameConstants.B_DEBUG) { console.log("CAT YELLOW"); }
                            break;
                    case 2:
                        this.aclo_cats[this.i_type].fu_SetCurrentFrame(this.cat_colors.GREEN);
                        if (GameConstants.B_DEBUG) { console.log("CAT GREEN"); }
                            break;
                    case 3:
                        this.aclo_cats[this.i_type].fu_SetCurrentFrame(this.cat_colors.BLUE);
                        if (GameConstants.B_DEBUG) { console.log("CAT BLUE"); }
                            break;
                    case 4:
                        this.aclo_cats[this.i_type].fu_SetCurrentFrame(this.cat_colors.PURPLE);
                        if (GameConstants.B_DEBUG) { console.log("CAT PURPLE"); }
                            break;
                    default:
                        if (GameConstants.B_DEBUG) { console.log("CAT RED"); }
                        break;
                }
            }

        }

        this.i_interval--;

        for (var i = this.aclo_cats.length; --i >= 0;)
            this.aclo_cats[i].fu_Update();

    }

    this.fu_Draw = function () {
        for (var i = this.aclo_cats.length; --i >= 0;)
            this.aclo_cats[i].fu_Draw();

    }

    this.fu_TidyUp = function () {

    }

}