﻿"use strict";

function Player() {

    this.image = [];

    this.b_visible = false;
    this.i_currentFrame = 0;
    this.i_frameDelay = 8;
    this.t_type = null;

    this.fu_LoadContent = function () {
        for (var i = 0; i < 2; i++)
            this.image[i] = new GameSprite();

        this.s_assetName = "player";

        this.image[0].fu_Initialize(this.s_assetName + "-0");
        this.image[1].fu_Initialize(this.s_assetName + "-1");
    }

    this.fu_Initialize = function () {

        this.position = new GameVec(400, 300);//GameScreen.i_wCenter, GameScreen.i_wCenter);


    }

    this.fu_Update = function () {

        // UPDATE PLAYER POSITION BASED ON GameControl INPUT
        for (var i = GameConstants.BUTTONS.length; --i >= 0;) {
            if (GameControl.a_buttons[i]) {
                if (i <= 39 && i > 34) {
                    this.i_type = GameElements.CatManager.cat_positions.LEFTBOTTOM;
                    if (GameConstants.B_DEBUG) { console.log("PLAYER BOTTOM LEFT"); }
                }
                if (i <= 34 && i > 29) {
                    this.i_type = GameElements.CatManager.cat_positions.BOTTOM;
                    if (GameConstants.B_DEBUG) { console.log("PLAYER BOTTOM"); }
                }
                if (i <= 29 && i > 24) {
                    this.i_type = GameElements.CatManager.cat_positions.RIGHTBOTTOM;
                    if (GameConstants.B_DEBUG) { console.log("PLAYER BOTTOM RIGHT"); }
                }
                if (i <= 24 && i > 19) {
                    this.i_type = GameElements.CatManager.cat_positions.RIGHT;
                    if (GameConstants.B_DEBUG) { console.log("PLAYER RIGHT"); }
                }
                if (i <= 19 && i > 14) {
                    this.i_type = GameElements.CatManager.cat_positions.RIGHTTOP;
                    if (GameConstants.B_DEBUG) { console.log("PLAYER TOP RIGHT"); }
                }
                if (i <= 14 && i > 9) {
                    this.i_type = GameElements.CatManager.cat_positions.TOP;
                    if (GameConstants.B_DEBUG) { console.log("PLAYER TOP"); }
                }
                if (i <= 9 && i > 4) {
                    this.i_type = GameElements.CatManager.cat_positions.LEFTTOP;
                    if (GameConstants.B_DEBUG) { console.log("PLAYER TOP LEFT"); }
                }
                if (i <= 4 && i >= 0) {
                    this.i_type = GameElements.CatManager.cat_positions.LEFT;
                    if (GameConstants.B_DEBUG) { console.log("PLAYER LEFT"); }
                }

                this.i_color = i % 5;
                switch (this.i_color) {
                    case 0:
                        if (GameConstants.B_DEBUG) { console.log("PLAYER RED"); }
                        break;
                    case 1:
                        if (GameConstants.B_DEBUG) { console.log("PLAYER YELLOW"); }
                        break;
                    case 2:
                        if (GameConstants.B_DEBUG) { console.log("PLAYER GREEN"); }
                        break;
                    case 3:
                        if (GameConstants.B_DEBUG) { console.log("PLAYER BLUE"); }
                        break;
                    case 4:
                        if (GameConstants.B_DEBUG) { console.log("PLAYER PURPLE"); }
                        break;
                    default:
                        if (GameConstants.B_DEBUG) { console.log("PLAYER DEFAULT"); }

                }

                if (GameElements.CatManager.aclo_cats[this.i_type].b_visible) {
                    if (GameElements.CatManager.aclo_cats[this.i_type].i_key == i) {
                        GameElements.CatManager.aclo_cats[this.i_type].b_visible = false;
                        Audio.fu_PlaySound(Audio.a_sounds[0].name)
                    }
                }

                GameControl.a_buttons[i] = false;

            }
        }

        this.fu_TidyUp();
    }

    this.fu_Draw = function () {
        if (this.i_frameDelay <= 0) {
            (++this.i_currentFrame >= 2 ? this.i_currentFrame = 0 : this.i_currentFrame);
            this.i_frameDelay = 8;
        } else
            this.i_frameDelay--;
        
        if (this.b_visible)
            this.image[this.i_currentFrame].fu_Draw();

    }

    this.fu_TidyUp = function () {
        this.image[this.i_currentFrame].position.i_x = this.position.i_x;
        this.image[this.i_currentFrame].position.i_y = this.position.i_y;
    }

}


Player.prototype = new GameSprite();