﻿// GAMECOLOR ====================================== //
// This class represents an RGBA color with values	//
// ranging from 0 to 255.							//
// ============================================ DJS //
function GameColor (r, g, b, a) {
	
	// VARIABLES / OBJECTS ---------------------------- //
	// ================================================ //
	this.r = (r == null ? 255 : r);		// RED CHANNEL
	this.g = (g == null ? 255 : g);		// GREEN CHANNEL
	this.b = (b == null ? 255 : b);		// BLUE CHANNEL
	this.a = (a == null ? 255 : a);		// ALPHA CHANNEL
	
	
	// TORGB ========================================== //
	// This method converts the stored RGB color 		//
	// values to a string which	follows the format:		//
	// "rgb(r,g,b)"										//
	// ============================================ DJS //
	this.ToRGB = function () {
		// CLAMP VALUES
		this.r = GameClamp.fu_Clamp(this.r, 0, 255);
		this.g = GameClamp.fu_Clamp(this.g, 0, 255);
		this.b = GameClamp.fu_Clamp(this.b, 0, 255);
		
		// RETURN FORMATTED STRING
		return "rgb(" + this.r + "," + this.g + "," + this.b + ")";
	}
	
}


// CLONE ========================================== //
// Creates a new GameColor based on an existing     //
// GameColor.                                       //
// ============================================ DJS //
GameColor.Clone = function (temp) {
    // RETURN THE CLONED GAMECOLOR
    return new GameColor(temp.r, temp.g, temp.b, temp.a);
}


// PREDEFINED GAMECOLORS -------------------------- //
// ================================================ //

// BASIC COLORS
GameColor.WHITE 				= new GameColor( 255, 	255, 	255);
GameColor.BLACK 				= new GameColor(   0, 	  0, 	  0);

// USER INTERFACE COLORS **TEMP**
GameColor.UI_BACKGROUND_1		= new GameColor(85,100,181);
GameColor.UI_BACKGROUND_2		= new GameColor(110,133,201);
GameColor.UI_ACCENT_1			= new GameColor(157,148,195);
GameColor.UI_ACCENT_2			= new GameColor(203,167,181);
GameColor.UI_FEATURE			= new GameColor(200,200,200);


// .                                                //
// .                                                //
// .                                                //
// CHANGE LOG ===================================== //
//                                                  //
// Dec. 1st, 2013 (DJS) --------------------------- //
//      * Added Clone method.						//
//                                                  //
// Nov. 30th, 2013 (DJS) -------------------------- //
//      * Created the file.							//
//                                                  //