"use strict";

var GameLoop = GameLoop || {};

GameLoop.f_fps;
GameLoop.s_state = "loading";

GameLoop.i_loading = 0;
GameLoop.i_loaded = 0;

GameLoop.fu_ContentCheck = function () {

    if (GameLoop.i_loading == GameLoop.i_loaded) {
        GameLoop.fu_SetState("initializing");
        GameLoop.fu_Initialize();
    }
}

GameLoop.fu_LoadContent = function () {

    if (GameConstants.B_DEBUG) { console.log('GameLoop Loading'); }

    // LOAD AUDIO STUFF
    Audio.fu_LoadContent();

    // LOAD STUFF
    GameElements.fu_LoadContent();

}

GameLoop.fu_Initialize = function () {

    if (GameConstants.B_DEBUG) { console.log('GameLoop Initializing'); }

    // INITIALIZE AUDIO
    Audio.fu_Initialize();

    // INITIALIZE GAME ELEMENTS
    GameElements.fu_Initialize();

    // INITIALIZE GameControl ARRAYS
    GameControl.fu_Initialize();
    if (GameConstants.B_DEBUG) { console.log('GameControl Initialized'); }

    // CALC FRAME UPDATE TIME
    GameLoop.f_fps = 1000 / GameConstants.F_FPS;

    // SET STATE RUNNIN
    GameLoop.fu_SetState("start");

    // SET GAME RUNNIN
    GameLoop.fu_SetRefresh();

}

GameLoop.fu_SetRefresh = function () {
    // SET WINDOW REFRESH RATE
    setInterval(GameLoop.fu_Run, GameLoop.f_fps);
}

GameLoop.fu_Run = function () {

    // UPDATE AUDIO ELEMENTS
    Audio.fu_Update();

    // UPDATE GAME ELEMENTS
    GameElements.fu_Update();

    // DRAW THE MATRIX TO THE SCREEN IN HTML
    GameElements.fu_Draw();

}


// STATE GameControlLER
GameLoop.fu_SetState = function (s_state) {
    GameLoop.s_state = s_state;
}

// SCENE HANDLING
// STRETCH GOAL - AUDIO HANDLER
// STRETCH GOAL - MORE ENEMY TYPES
// STRETCH GOAL - LEADERBOARD?